#include "src/ATBAPP/ATBVMCPlugin.h"

#include <QTimer>
#include <QThread>
#include <QTextCodec>
#include <QDebug>

#include <QPluginLoader>
#include <QDateTime>
#include <QFileInfo>
#include <QCoreApplication>
#include <QUuid>

#include <cstdlib>

ATBVMCPlugin::ATBVMCPlugin(QObject *parent)
  : VMCInterface(parent)
  , m_errorCode("")
  , m_errorDescription("")
  , m_pluginInfo("")
  , m_serialPortName("")
  , m_useDebug(false)
  , m_pluginState(PLUGIN_STATE::NOT_INITIALIZED)
  , m_eventReceiver(nullptr)
  , m_settings(nullptr)
  , m_config(nullptr) {
}

ATBVMCPlugin::~ATBVMCPlugin() {
}

PLUGIN_STATE ATBVMCPlugin::initVMCPlugin(QObject *eventReceiver,
                                         QSettings const &settings) {
    m_eventReceiver = eventReceiver;
    m_settings = &settings;

    // Beachte: QSettings hat .fileName().
    // Damit kann man dann ATBSystem benutzen.

    return PLUGIN_STATE::INITIALIZED;
}

PLUGIN_STATE ATBVMCPlugin::initVMCPlugin(QObject *eventReceiver, ATBHMIconfig *config) {
    m_eventReceiver = eventReceiver;
    m_settings = &config->getSettings();
    m_config = config;
    return PLUGIN_STATE::INITIALIZED;
}

// mandantory ATBAPP plugin methods: ------------------------------------------
PLUGIN_STATE ATBVMCPlugin::getState() {
    return PLUGIN_STATE::NOT_INITIALIZED;
}

QString ATBVMCPlugin::getLastError() {
    return "";
}

QString ATBVMCPlugin::getLastErrorDescription() {
    return "";
}

QString const &ATBVMCPlugin::getPluginInfo() {
    static QString info;
    return info;
}

// helpers e.g. for debug / log
QString ATBVMCPlugin::getString(RESULT_STATE /*resultState*/) {
    return "";
}

void ATBVMCPlugin::onChangedProgramModeToSELL() {

}

void ATBVMCPlugin::onChangedProgramModeToSERVICE() {

}

void ATBVMCPlugin::onChangedProgramModeToIDLE() {

}

void ATBVMCPlugin::onChangedProgramModeToOOO() {

}

void ATBVMCPlugin::startPhysicalLayer() {

}

void ATBVMCPlugin::stopPhysicalLayer() {

}

void ATBVMCPlugin::reboot() {

}

void ATBVMCPlugin::reset() {

}
